package PriorityQueues;

import Heaps.*;
import SearchKeys.KeyedItem;
// *********************************************************
// Assumes that Heap implementation is in package Heaps.
// PriorityQueue class implementation.
// *********************************************************

public class PriorityQueue {
  private Heap h;

  public PriorityQueue() {
    h = new Heap();
  }  // end default constructor

  // priority-queue operations:
  public boolean pqIsEmpty() {
    return h.heapIsEmpty();
  }  // end pqIsEmpty

  public void pqInsert(KeyedItem newItem) 
                       throws PQueueException {
    try {
      h.heapInsert(newItem);
    }  // end try
    catch (HeapException e) { throw new PQueueException(
                 "PQueueException: Priority queue full");
    }  // end catch
  }  // end pqInsert

  public KeyedItem pqDelete() {
    return h.heapDelete();
  }  // end pqDelete
   
}  // end PriorityQueue